#include "stdafx.h"
#include "NeMessenger.h"
#include "ConfirmationNumberDlg.h"

#define CN_DLG_BTN_WIDTH			70
#define CN_DLG_BTN_HEIGHT			28
#define CN_DLG_BTN_GAP_X			4
#define BTN_HEIGHT					36
#define CN_DLG_COLOR_TEXT_NAME			(RGB(102, 102, 102))		// #666666
#define CN_DLG_COLOR_TEXT_VALUE			(RGB(94, 95, 109))		// #5E5F6D

IMPLEMENT_DYNAMIC(CConfirmationNumberDlg, CSkinDialog)

CConfirmationNumberDlg::CConfirmationNumberDlg(CWnd* pParent, CString strSystemName)
	: CSkinDialog(CConfirmationNumberDlg::IDD, pParent)
{
	m_strConfirmNo = _T("");
	m_strSystemName = strSystemName;
	m_pOKCancelButtons = NULL;
}

CConfirmationNumberDlg::~CConfirmationNumberDlg()
{
	m_penBorder.DeleteObject();
}

void CConfirmationNumberDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_CONFIRM_NO, m_edConfirmNo);
}


BEGIN_MESSAGE_MAP(CConfirmationNumberDlg, CSkinDialog)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_CREATE()
END_MESSAGE_MAP()


BOOL CConfirmationNumberDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	ModifyStyle(0, WS_THICKFRAME);
	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(m_strSystemName);

	m_penBorder.CreatePen(PS_SOLID, 1, RGB(220,220,220));

	m_edConfirmNo.SetFont(&g_ftDefault12PX);

	__ResourceLoad(TRUE);
	//  â 
	MoveWindow(0, 0, 390, 220);
	CenterWindow();
	//SetSkin();
	ReSizeCtrl();
	RedrawWindow();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CConfirmationNumberDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CConfirmationNumberDlg::ReSizeCtrl()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	// ư ġ
	if(m_pOKCancelButtons && m_pOKCancelButtons->GetHWND())
	{
		CRect rcButtons(rcClient.left, rcClient.bottom+7 - BTN_HEIGHT, rcClient.right, rcClient.bottom + 7);
		m_pOKCancelButtons->SetClientRect(rcButtons);
	}

	if (m_edConfirmNo.GetSafeHwnd())
	{
		m_edConfirmNo.MoveWindow(90, 80, 260, 20, TRUE);
	}
}

void CConfirmationNumberDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	//memDC.MoveTo(0, 0);
	//memDC.LineTo(rcClient.right, 0);

	// ϴ μ
	/*memDC.MoveTo(0, rcClient.bottom - 48);
	memDC.LineTo(rcClient.right, rcClient.bottom - 48);*/

	CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PT);
	memDC.SetBkMode(TRANSPARENT);
	memDC.SetTextColor(CN_DLG_COLOR_TEXT_NAME);
	CRect rtText(20, 40, 350, 70);
	CString strSystemName;
	strSystemName.Format(LoadStringFromResource(IDS_STRING375), m_strSystemName);
	memDC.DrawText(strSystemName, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);

	memDC.SelectObject(&g_ftDefault9PTB);
	rtText = CRect(20, 82, 90, 100);
	memDC.DrawText(LoadStringFromResource(IDS_STRING376), &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
}

void CConfirmationNumberDlg::OnOK()
{
	m_edConfirmNo.GetWindowText(m_strConfirmNo);

	CSkinDialog::OnOK();
}

void CConfirmationNumberDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit == TRUE)
	{
		SetWindowText(LoadStringFromResource(IDS_STRING567));
		SetShowTitle(FALSE);
		SetDialogShowWindowText(true);
		SetDialogWindowText(LoadStringFromResource(IDS_STRING567));
		SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
		SetWindowTextFontHeight(12);

		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
		SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);
	}
	else
	{

	}

	if(g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{

	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{


	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{

	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{

	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{

	}

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CConfirmationNumberDlg::OnButtonClicked( COKCancelButtons::BUTTONS button )
{
	ASSERT(button != COKCancelButtons::All);

	if(button == COKCancelButtons::OK)
	{
		OnOK();
	}
	else if(button == COKCancelButtons::Cancle)
	{
		OnCancel();
	}
	else
	{
		ASSERT(FALSE);
	}
}

int CConfirmationNumberDlg::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pOKCancelButtons = new COKCancelButtons(this, this);
	m_pOKCancelButtons->LoadSkin();

	m_pOKCancelButtons->SetButtonText(LoadStringFromResource(IDS_STRING568), 
		LoadStringFromResource(IDS_STRING569));

	return 0;
}

void CConfirmationNumberDlg::OnDestroy()
{
	if(m_pOKCancelButtons)
	{
		::DestroyWindow(m_pOKCancelButtons->GetHWND());
		SAFE_DELETE(m_pOKCancelButtons);
	}

	__super::OnDestroy();
}
